<?php

namespace TB\BenzerKonular\Repository;

use XF\Mvc\Entity\Repository;

class BenzerKonular extends Repository
{
	public function getBenzerKonular($currentNodeId, $currentThreadId, $threadTitle)
	{
		$options = \XF::options();			
		$gunSiniri = $options->benzerKonularGunSiniri;
		$haricForumlar = $options->benzerKonularHaricForumlar;				
		$konuSayisi = $options->benzerKonularKonuSayisi;				
		$ayniForum = $options->benzerKonularAyniForum;				
		$searchWords = array();
		$searchWord1 = '';
		$searchWord2 = '';
		$searchWord3 = '';
		$results1 = array();
		$results2 = array();
		$results3 = array();
		$results4 = array();
		$results5 = array();
		
		if (in_array($currentNodeId, $haricForumlar))
		{
			return;
		}

		$threadTitleArray = explode(' ', $threadTitle);
		
		foreach ($threadTitleArray as $var)
		{
		    $searchWords[] = $var;			
		}

		$count = count($searchWords);

		if ($count == 0)
		{
			return;
		}			
		
		if ($count > 0)
		{				
			$searchWord1 = $searchWords[0];
			
			if ($count > 1)
			{	
				$searchWord2 = $searchWords[1];	
			}
			
			if ($count > 2)
			{	
				$searchWord3 = $searchWords[2];	
			}							
		}			
		
		if ($gunSiniri > 0)
		{
			$gte = time() - (86400 * $gunSiniri);
		}
		else
		{
			$gte = 0;
		}
		
		if (!$ayniForum)
		{
			$nodeRepo = $this->repository('XF:Node');
			$nodes = $nodeRepo->getNodeList();
			$nodeIds = $nodes->keys();
			
			$arr = array_diff($nodeIds, $haricForumlar);
			$result = array_values($arr);
			
			foreach ($result AS $k => $v)
			{
				$conditionsOr[] = ['node_id', '=', $v];
			}
		}
		
		if ($ayniForum)
		{
			$currentNodeIdArray = $currentNodeId;
			
			$conditionsOr[] = ['node_id', '=', $currentNodeIdArray];
		}				

		if ($searchWord1 != '' AND $searchWord2 != '' AND $searchWord3 != '')
		{
			$konuSayisi1 = $konuSayisi;	
	
			$finder = \XF::finder('XF:Thread');
			$threads1 = $finder
				->where('title', 'LIKE', $finder->escapeLike($searchWord1, '%?%'))
				->where('title', 'LIKE', $finder->escapeLike($searchWord2, '%?%'))
				->where('title', 'LIKE', $finder->escapeLike($searchWord3, '%?%'))
				->where('discussion_state', '=', 'visible')
				->where('discussion_type', '<>', 'redirect')
				->where('post_date', '>=', $gte)
				->where('thread_id', '<>', $currentThreadId)
				->whereOr($conditionsOr)
				->order('post_date', 'DESC')
				->limit($konuSayisi1)
				->fetch();

			foreach ($threads1 as $k => $v)
			{
				$results1[] = array(
					'thread_id' => $v->thread_id
				);
			}

			$results = $results1;
		}
				
		if ($searchWord1 != '' AND $searchWord2 != '')
		{				
			foreach ($results1 AS $k => $v)
			{
				$threadId = $v['thread_id'];
				$conditions[] = ['thread_id', '<>', $threadId];
			}
			
			if (empty($conditions))
			{
				$conditions = [];
			}

			$count = count($results1);	

			if ($count < $konuSayisi AND is_numeric($count))
			{
				$konuSayisi2 = $konuSayisi - $count;

				$finder = \XF::finder('XF:Thread');
				$threads2 = $finder
					->where('title', 'LIKE', $finder->escapeLike($searchWord1, '%?%'))
					->where('title', 'LIKE', $finder->escapeLike($searchWord2, '%?%'))
					->where('discussion_state', '=', 'visible')
					->where('discussion_type', '<>', 'redirect')
					->where('post_date', '>=', $gte)
					->where('thread_id', '<>', $currentThreadId)
					->where($conditions)
					->whereOr($conditionsOr)
					->order('post_date', 'DESC')
					->limit($konuSayisi2)
					->fetch();

				foreach ($threads2 as $k => $v)
				{
					$results2[] = array(
						'thread_id' => $v->thread_id
					);
				}	

				$results = array_merge($results1, $results2);
			}
		}		
		
		if ($searchWord1 != '')
		{	
			foreach ($results2 AS $k => $v)
			{
				$threadId = $v['thread_id'];
				$conditions[] = ['thread_id', '<>', $threadId];
			}
			
			if (empty($conditions))
			{
				$conditions = [];
			}
			
			$count = count($results1) + count($results2);

			if ($count < $konuSayisi AND is_numeric($count))
			{
				$konuSayisi3 = $konuSayisi - $count;

				$finder = \XF::finder('XF:Thread');
				$threads3 = $finder
					->where('title', 'LIKE', $finder->escapeLike($searchWord1, '%?%'))
					->where('discussion_state', '=', 'visible')
					->where('discussion_type', '<>', 'redirect')
					->where('post_date', '>=', $gte)
					->where('thread_id', '<>', $currentThreadId)
					->where($conditions)
					->whereOr($conditionsOr)
					->order('post_date', 'DESC')
					->limit($konuSayisi3)
					->fetch();

				foreach ($threads3 as $k => $v)
				{
					$results3[] = array(
						'thread_id' => $v->thread_id
					);
				}

				$results = array_merge($results1, $results2, $results3);
			}
		}
		
		if ($searchWord2 != '')
		{
			foreach ($results3 AS $k => $v)
			{
				$threadId = $v['thread_id'];
				$conditions[] = ['thread_id', '<>', $threadId];
			}
			
			if (empty($conditions))
			{
				$conditions = [];
			}
			
			$count = count($results1) + count($results2) + count($results3);

			if ($count < $konuSayisi AND is_numeric($count))
			{
				$konuSayisi4 = $konuSayisi - $count;
				
				$finder = \XF::finder('XF:Thread');
				$threads4 = $finder
					->where('title', 'LIKE', $finder->escapeLike($searchWord2, '%?%'))
					->where('discussion_state', '=', 'visible')
					->where('discussion_type', '<>', 'redirect')
					->where('post_date', '>=', $gte)
					->where('thread_id', '<>', $currentThreadId)
					->where($conditions)
					->whereOr($conditionsOr)
					->order('post_date', 'DESC')
					->limit($konuSayisi4)
					->fetch();

				foreach ($threads4 as $k => $v)
				{
					$results4[] = array(
						'thread_id' => $v->thread_id
					);
				}	
				
				$results = array_merge($results1, $results2, $results3, $results4);
			} 
		}
		
		if ($searchWord3 != '')
		{
			foreach ($results4 AS $k => $v)
			{
				$threadId = $v['thread_id'];
				$conditions[] = ['thread_id', '<>', $threadId];
			}
			
			if (empty($conditions))
			{
				$conditions = [];
			}
			
			$count = count($results1) + count($results2) + count($results3) + count($results4);

			if ($count < $konuSayisi AND is_numeric($count))
			{
				$konuSayisi5 = $konuSayisi - $count;
				
				$finder = \XF::finder('XF:Thread');
				$threads5 = $finder
					->where('title', 'LIKE', $finder->escapeLike($searchWord2, '%?%'))
					->where('discussion_state', '=', 'visible')
					->where('discussion_type', '<>', 'redirect')
					->where('post_date', '>=', $gte)
					->where('thread_id', '<>', $currentThreadId)
					->where($conditions)
					->whereOr($conditionsOr)
					->order('post_date', 'DESC')
					->limit($konuSayisi5)
					->fetch();

				foreach ($threads5 as $k => $v)
				{
					$results5[] = array(
						'thread_id' => $v->thread_id
					);
				}	
				
				$results = array_merge($results1, $results2, $results3, $results4, $results5);
			} 
		}	
 
		if (empty($results))
		{
			return;
		}
		
		unset($conditions);
		
		foreach ($results AS $k => $v)
		{
			$threadId = $v['thread_id'];
			$conditions[] = ['thread_id', '=', $threadId];
		}

		if (!empty($conditions))
		{
			$finder = \XF::finder('XF:Thread');
			$benzerKonular = $finder
				->whereOr($conditions)
				->order('post_date', 'DESC')
				->fetch();
		}
		else
		{
			$benzerKonular = array();
		}

		return $benzerKonular;
	}
	
}